#include "fdbuf.h"

///////////////////////////////////////////////////////////////////////////////
// Other routines
///////////////////////////////////////////////////////////////////////////////
bool fdbuf_copy(fdibuf& in, fdobuf& out, bool noflush)
{
  if(in.eof())
    return true;
  if(!in || !out)
    return false;
  do {
    char buf[BUFSIZE];
    if(!in.read(buf, BUFSIZE) && in.last_count() == 0)
      break;
    if(!out.write(buf, in.last_count()) && out.last_count() < in.last_count())
      return false;
  } while(!in.eof());
  if(!noflush && !out.flush())
    return false;
  return in.eof();
}
